package ensembles;

import tableaux.Tableau;

public class EnsembleTriTableau2<E extends Comparable<E>> extends EnsembleTriGenerique<E> {

	protected Tableau<E> tableau;
	
	public EnsembleTriTableau2()
	{
		this.tableau = new Tableau<E>();
	}

	/**
	 * Constructeur de copie à partir d'un autre iterable
	 *
	 * @param elements l'itrable dont on veut copier les lments
	 */
	public EnsembleTriTableau2(Iterable<E> elements)
	{
		this.tableau = new Tableau<E>();
		int rang;
		for(E elt : elements) {
			
			if(!this.contient(elt)) {
				rang = this.rang(elt);
				this.insererAuRang(elt, rang);
			}
			
		}
	}
	
	@Override
	protected boolean insererAuRang(E element, int rang) {
		boolean res = false;
		if(rang>0 && rang<this.cardinal()) {
			this.tableau.insertElement(element, rang);
			return true;
		}
		return res;
	}

}
