package ensembles;

import java.util.Iterator;
import java.util.Vector;

public class EnsembleVector<E> extends EnsembleGenerique<E>{

	protected Vector<E> vector;
	
	/**
	 * Constructeur par dfaut d'un ensemble à base de {@link tableaux.Tableau}
	 */
	public EnsembleVector()
	{
		this.vector = new Vector<E>();
	}

	/**
	 * Constructeur de copie à partir d'un {@link Iterable}
	 *
	 * @param elements l'itrable dont on doit copier les lments
	 */
	public EnsembleVector(Iterable<E> elements)
	{	
		this.vector = new Vector<E>();
		for(E elt : elements) {
			if(!this.contient(elt)) {
				this.vector.add(elt);
			}
		}
	}
	
	@Override
	public boolean ajout(E element) {
		if(element==null) {
			return false;
		}
		else {
			if(this.contient(element)) {
				return false;
			}
			else {
				this.vector.add(element);
				return true;
			}
		}
	}
	
	@Override
	public int cardinal()
	{
		return this.vector.size();
	}

	@Override
	public Ensemble<E> union(Ensemble<E> ensemble) {
		Ensemble<E> res = new EnsembleVector<E>();
		Ensemble.union(ensemble, this, res);
		return res;
	}

	@Override
	public Ensemble<E> intersection(Ensemble<E> ensemble) {
		Ensemble<E> res = new EnsembleVector<E>();
		Ensemble.intersection(ensemble, this, res);
		return res;
	}

	@Override
	public Ensemble<E> complement(Ensemble<E> ensemble) {
		Ensemble<E> res = new EnsembleVector<E>();
		Ensemble.complement(ensemble, this, res);
		return res;
	}

	@Override
	public Iterator<E> iterator() {
		return this.vector.iterator();
	}

}
